#!/bin/sh

PACKAGE_NAME="CloudStationClient"
PRIVATE_LOCATION="/var/packages/${PACKAGE_NAME}/target"
PKG_BIN_PATH="${PRIVATE_LOCATION}/bin"
SRV_CONTROL_BIN="${PKG_BIN_PATH}/srvctl"
CONF_LOCATION="/var/packages/${PACKAGE_NAME}/etc"
CONF_FILE_PATH="${CONF_LOCATION}/service.conf"
REPO_VOL_KEY="volume"

dscc_change_vol()
{
	logger -p 0 "start to move from ${1}/@CloudStationClient to ${2}/@CloudStationClient"

	local from_loc="${1}";
	local to_loc="${2}";

	if [ ! -d "${from_loc}/@CloudStationClient" ]; then
		logger -p 0 "$from_loc/@CloudStationClient does not exist"
		return;
	fi

	touch "/tmp/dscc_repo_mv"

	#In different volumes
	rm -rf "${to_loc}/@CloudStationClient" > /dev/null 2>&1
	mv -f "${from_loc}/@CloudStationClient" "${to_loc}/@CloudStationClient"  > /dev/null 2>&1

	# handle cp fail
	if [ 0 -ne $? ]; then
		logger -p 0 "cp \"${from_loc}/@CloudStationClient\" \"${to_loc}/@CloudStationClient\" fail, fall back"
		mv "${to_loc}/@CloudStationClient" "${to_loc}/@tmp/@CloudStationClient"  > /dev/null 2>&1
		rm -rf  "${to_loc}/@tmp/@CloudStationClient" &
		rm -rf "/tmp/dscc_repo_mv"
		return 1;
	fi

	mv "${from_loc}/@CloudStationClient" "${from_loc}/@tmp/@CloudStationClient"  > /dev/null 2>&1
	rm -rf  "${from_loc}/@tmp/@CloudStationClient" &

	logger -p 0 "move repository from ${from_loc}/@CloudStationClient to ${to_loc}/@CloudStationClient successfully"

	# change repo vol in conf file
	/usr/syno/bin/synosetkeyvalue ${CONF_FILE_PATH} "${REPO_VOL_KEY}" "${to_loc}"

	rm -rf "/tmp/dscc_repo_mv"
}

if [ 2 -ne $# ]; then
	echo "usage [from] [to]"
	return 1;
fi

(flock -n 200 || exit 1

# FIXME: stop all process
"${SRV_CONTROL_BIN}" --stop > /dev/null 2>&1;

dscc_change_vol "${1}" "${2}" ;

# FIXME: launch all process
"${SRV_CONTROL_BIN}" --start > /dev/null 2>&1

) 200> /tmp/dscc_repo_mv.flock
